use super::*;

pub enum Selected<'a, A: 'a, B: 'a, T: ?Sized + 'a + WeakFunctor> {
    A(A, T::F<'a, B>),
    B(T::F<'a, A>, B),
}

pub type SelectedWrapped<'a, A, B, T> = Wrap<'a, Selected<'a, A, B, T>, T>;

pub trait ApplicativeSelect: Functor {
    fn select<'a, A: 'a, B: 'a>(
        fa: Self::F<'a, A>,
        fb: Self::F<'a, B>,
    ) -> SelectedWrapped<'a, A, B, Self>
    where
        Self: 'a,
    {
        Self::fmap(|a| Selected::A(a, fb), fa)
    }
}
